/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE QuickTime Components SOURCE CODE.       *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS LIBRARY SOURCE IS     *
 * GOVERNED BY A BSD-STYLE SOURCE LICENSE INCLUDED WITH THIS SOURCE *
 * IN 'COPYING'. PLEASE READ THESE TERMS BEFORE DISTRIBUTING.       *
 *                                                                  *
 * THE QuickTime Components SOURCE CODE IS (C) COPYRIGHT 2001-2002  *
 * by Steve Nicolai http://qtcomponents.sourceforge.net/            *
 *                                                                  *
 ********************************************************************

 function: QuickTime Movie Export component resources
 last mod: $$

 ********************************************************************/

#define TARGET_REZ_WIN32 1


// use the platform info array in the 'thng' resource for 68k and PowerPC, or Windows
/*
    thng_RezTemplateVersion:
        0 - original 'thng' template    <-- default
        1 - extended 'thng' template	<-- used for multiplatform things
        2 - extended 'thng' template including resource map id
*/
#define thng_RezTemplateVersion 2

/*
    cfrg_RezTemplateVersion:
        0 - original					<-- default
        1 - extended
*/
#define cfrg_RezTemplateVersion 1

/* @@@@ what's this? */
#define DLOG_RezTemplateVersion 1


    #include "ConditionalMacros.r"
    #include "MacTypes.r"
    #include "Components.r"
    #include "QuickTimeComponents.r"
    #include "CodeFragments.r"

#include "LAMECodec.h"

#define kExporterComponentType 'spit'

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// LAME Exporter

#define kMyComponentFlags	canMovieExportFiles | canMovieExportValidateMovie | movieExportMustGetSourceMediaType | canMovieExportFromProcedures | hasMovieExportUserInterface


resource 'thng' (kExporterResID, LAMEExporterName, purgeable) {
    kExporterComponentType, kCodecFormat, kSoundComponentManufacturer, 
    0, 0, 0, 0,
    'STR ', kExporterNameStringResID,
    'STR ', kExporterInfoStringResID,
    0, 0,		// no icon
    kExporterVersion,
    componentHasMultiplePlatforms, // + componentDoAutoVersion, 
	0, 
	{
		#if TARGET_OS_MAC
			#if TARGET_REZ_CARBON_MACHO
				#if !(TARGET_REZ_MAC_PPC || TARGET_REZ_MAC_X86)
					#error "Platform architecture not defined!"
				#endif
				#if TARGET_REZ_MAC_PPC
					  kMyComponentFlags,
					  'dlle',
					  kExporterResID,
					  platformPowerPCNativeEntryPoint,  // PowerPC-based Macintosh
				#endif
				#if TARGET_REZ_MAC_X86
					  kMyComponentFlags,
					  'dlle',
					  kExporterResID,
					  platformIA32NativeEntryPoint,     // Intel-based Macintosh
				#endif
			#else
				#error "TARGET_REZ_CARBON_MACHO should be defined."
			#endif
		#elif TARGET_OS_WIN32
			#if TARGET_REZ_WIN32
				kMyComponentFlags,
				'dlle',
				kExporterResID,
				platformWin32,
			#else
				#error "TARGET_REZ_WIN32 should be defined."
			#endif
		#else
			#error "I have no idea what you're trying to do!"
		#endif
    },
    'thnr', kExporterResID
};

resource 'thnr' (kExporterResID, LAMEExporterName, purgeable) {
    {
        'src#', 1, 0, 'src#', 1, cmpResourceNoFlags,
        'src#', 2, 0, 'src#', 2, cmpResourceNoFlags,
		
        'stg#', 1, 0, 'stg#', kExporterResID, cmpResourceNoFlags,
		
        'STR#', kExporterResID, 0, 'STR#', kExporterResID, cmpResourceNoFlags,
        'STR#', kExporterResID+1, 0, 'STR#', kExporterResID+1, cmpResourceNoFlags,

        'sttg', kExporterResID, 0, 'sttg', kExporterResID, cmpResourceNoFlags,
        'sttg', kExporterResID+1, 0, 'sttg', kExporterResID+1, cmpResourceNoFlags,
        'sttg', kExporterResID+2, 0, 'sttg', kExporterResID+2, cmpResourceNoFlags,
    };
};


//#if TARGET_REZ_CARBON_MACHO || TARGET_REZ_WIN32
resource 'dlle' (kExporterResID, LAMEExporterName) {
    "LAMEExportComponentDispatch"
};
//#endif


/*
#if TARGET_REZ_CARBON_CFM
// Custom extended code fragment resource
// CodeWarrior will correctly adjust the offset and length of each
// code fragment when building a MacOS Merge target
resource 'cfrg' (0) {
    {		
        extendedEntry {
            kPowerPCCFragArch,			// archType
            kIsCompleteCFrag,			// updateLevel
            kNoVersionNum,			// currentVersion
            kNoVersionNum,			// oldDefVersion
            kDefaultStackSize,			// appStackSize
            kNoAppSubFolder,			// appSubFolderID
            kImportLibraryCFrag,		// usage
            kDataForkCFragLocator,		// where
            kZeroOffset,			// offset
            kCFragGoesToEOF,			// length
            "LAME Sound Exporter",	// member name
			
            // Start of extended info.
			
            'cpnt',                             // libKind (not kFragComponentMgrComponent == 'comp' as you might expect)
            "\0x0B\0xB8",                       // qualifier 1 - hex 0x0BB8 (3000) matches Code ID in 'thng'
            "",	                                // qualifier 2
            "",	                                // qualifier 3
            "LAME Sound Exporter",        // intlName, localised
        };
    };
};
#endif
*/

// name and info string are shared by the compressor and decompressor
resource 'STR ' (kExporterNameStringResID, LAMEExporterName, purgeable) {
    "LAME MP3"
};

resource 'STR ' (kExporterInfoStringResID, LAMEExporterName, purgeable) {
    "LAME MP3 " kLAMECodecVersion " (See http://lame.sourceforge.net/)."
};


// Our exporter can only handle one sound track
resource 'src#' (1) {
    {
        'soun', 1, 1, isSourceType
    }
};

resource 'src#' (2) {
    {
        'soun', 1, 1, isSourceType
    }
};

//JS:
resource 'stg#' (kExporterResID) {
    0,		// flags
    {
        'stGd',	                        // key
        0,			        // flags
        'sttg', kExporterResID,
        kExporterResID, 1,		// Good
        kExporterResID+1, 1,

        'stBt',	                        // key
        0,                              // flags
        'sttg', kExporterResID+1,
        kExporterResID, 2,		// Better
        kExporterResID+1, 2,

        'stHi',                         // key
        0,                              // flags
        'sttg', kExporterResID+2,
        kExporterResID, 3,		// High
        kExporterResID+1, 3,
    };
};


// preset names
resource 'STR#' (kExporterResID) {
    {
        "Good Quality (128 kbps)",
		"Better Quality (160 kbps)",
		"High Quality (192 kbps)"
    }
};

// preset descriptions
resource 'STR#' (kExporterResID+1) {
    {
        "Good Quality (128 kbps)",
		"Better Quality (160 kbps)",
		"High Quality (192 kbps)"
    }
};

// settings is an atom container.
type 'sttg' {
    // 10 bytes of reserved
    longint = 0;
    longint = 0;
    integer = 0;
    // 2 bytes of lock count
    integer = 0;
    
    // size of this atom
    parentStart:
    longint = ( (parentEnd - parentStart) / 8 );
    
    // atom type
    literal longint = 'sean';
    
    // atom id
    longint = 1;
    integer = 0;
    integer =  1;
    longint = 0;
    
    containerStart:
    longint = ( (containerEnd - containerStart) / 8 );
    
    // atom type
    literal longint = kLAMESettingsAtom;
    
    // atom id
    longint = 1;
    integer = 0;
    integer =  $$CountOf(AtomArray);
    longint = 0;
    
    array AtomArray {
        atomStart:
        // size of this atom
        longint = ((atomEnd[$$ArrayIndex(AtomArray)] - atomStart[$$ArrayIndex(AtomArray)]) / 8);
        
        // atom type
        literal longint;
        
        // atom id
        longint;
        integer = 0;
        integer = 0; // no children
        longint = 0;
        
        longint;		// the data
        atomEnd:
        };
    containerEnd:
    parentEnd:
        
};


// actual settings atoms for Good
resource 'sttg' (kExporterResID) {
    {
        kLAMESettingsVersionAtom,    1, 1;
        kLAMESettingsQualityAtom,    2, 128;	/* quality is expressed kbps here */
        kVorbisSettingsMinBitRateAtom, 3, -1;
        kVorbisSettingsAvgBitRateAtom, 4, -1;
        kVorbisSettingsMaxBitRateAtom, 5, -1;
    }
};

// actual settings atoms for Better
resource 'sttg' (kExporterResID+1) {
    {
        kLAMESettingsVersionAtom,    1, 1;
        kLAMESettingsQualityAtom,    2, 160;	/* quality is expressed kbps here */
        kVorbisSettingsMinBitRateAtom, 3, -1;
        kVorbisSettingsAvgBitRateAtom, 4, -1;
        kVorbisSettingsMaxBitRateAtom, 5, -1;
    }
};

// actual settings atoms for High
resource 'sttg' (kExporterResID+2) {
    {
        kLAMESettingsVersionAtom,    1, 1;
        kLAMESettingsQualityAtom,    2, 192;	/* quality is expressed kbps here */
        kVorbisSettingsMinBitRateAtom, 3, -1;
        kVorbisSettingsAvgBitRateAtom, 4, -1;
        kVorbisSettingsMaxBitRateAtom, 5, -1;
    }
};

