#pragma once
#if __cplusplus
#include "afxwin.h"
#endif

#ifndef LAME_LAME_H
#include "lame.h"
#endif

#pragma pack(push,1)
typedef struct {
	vbr_mode vbrMode;
	int vbrQuality;
	MPEG_mode stereoMode;
	int sampleRate;
	int bitRate;
	int quality;
} LAME_Settings;
#pragma pack(pop)


#if __cplusplus
extern "C" {
#endif

	HRESULT ShowSettings(LAME_Settings* ls, HWND hParent);

#if __cplusplus
}
// CLAMESettings dialog

class CLAMESettings : public CDialog
{
	DECLARE_DYNAMIC(CLAMESettings)

public:
	CLAMESettings(LAME_Settings& s, CWnd* pParent = NULL);   // standard constructor
	virtual ~CLAMESettings();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_LAMESETTINGS };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	virtual BOOL OnInitDialog();
	CComboBox m_Combo_Type;
	CComboBox m_Combo_VBR_Quality;
	CComboBox m_Combo_Channels;
	CComboBox m_Combo_Sample_Rate;
	CComboBox m_Combo_Bit_Rate;
	CComboBox m_Combo_Quality;
	afx_msg void OnTypeChanged();
	afx_msg void OnVBRQualityChanged();
	afx_msg void OnChannelsChanged();
	afx_msg void OnSampleRateChanged();
	afx_msg void OnBitRateChanged();
	afx_msg void OnQualityChanged();
	HRESULT LoadCombo(CComboBox& combo, int nFirstString, int nLastString);

protected:
	LAME_Settings& settings;
};

#endif
